/*
  Windows Sockets FTP Application

  Written by: John A. Junod            Internet: <junodj@gordon-emh2.army.mil>
              267 Hillwood Street                <zj8549@trotter.usma.edu>
              Martinez, GA 30907     Compuserve: 72321,366 

  This program executable and all source code is released into the public
  domain.

  MODULE: WS_FTP.H   (main program header file)
*/

#include <string.h>

#ifndef INADDR_NONE
#define INADDR_NONE 0xffffffff
#endif

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 64
#endif

#define MAXPACKET 4096

#define IDM_ABOUT                   1000
#define IDM_CLOSE                   1010
#define IDM_CONNECT                 1020
#define IDM_EDIT                    1030
#define IDM_EXIT                    1040
#define IDM_MAIN                    1050

#define CMD_CWD                     1110
#define CMD_HELP                    1120
#define CMD_LIST                    1130
#define CMD_MKD                     1140
#define CMD_NLST                    1151
#define CMD_PWD                     1160
#define CMD_QUOTE                   1170
#define CMD_RMD                     1180
#define CMD_STATUS                  1190

#define BTN_STAT                    2010
#define BTN_CONNECT                 2020
#define BTN_EXIT                    2030

#define BTN_LCHANGE                 2110
#define DLG_LDIRECTORY              2120
#define DLG_LDIRS                   2130
#define DLG_LFILES                  2140
#define BTN_LOCAL_TO_REMOTE         2150
#define BTN_LMKDIR                  2160
#define BTN_LRMDIR                  2170
#define BTN_LDELETE                 2180
#define BTN_LRENAME                 2190

#define BTN_RCHANGE                 2210
#define DLG_RDIRECTORY              2220
#define DLG_RDIRS                   2230
#define DLG_RFILES                  2240
#define BTN_REMOTE_TO_LOCAL         2250
#define BTN_RMKDIR                  2260
#define BTN_RRMDIR                  2270
#define BTN_RDELETE                 2280
#define BTN_RRENAME                 2290

#define DLG_BELL                    3010
#define DLG_CRSTRIP                 3011
#define DLG_EDIT                    3012
#define DLG_GLOBBING                3013
#define DLG_HASH                    3014
#define DLG_HOSTNAME                3015
#define DLG_INTERACTIVE             3016
#define DLG_MCASE                   3017
#define DLG_TYPE_ASCII              3018
#define DLG_TYPE_BINARY             3019
#define DLG_TYPE_EBCDIC             3020
#define DLG_TYPE_IMAGE              3021
#define DLG_TYPE_TENEX              3022
#define DLG_PORT_CMDS               3023
#define DLG_PROMPT                  3024
#define DLG_RECV_UNIQUE             3025
#define DLG_STOR_UNIQUE             3026
#define DLG_VERBOSE                 3027

#define EDIT_HOST                   6001
#define EDIT_PASSWD                 6003
#define EDIT_USERID                 6002

#define IDS_ERR_CREATE_WINDOW        101
#define IDS_ERR_REGISTER_CLASS       102

#define TYPE_I 'I'
#define TYPE_A 'A'
#define TYPE_E 'E'
#define TYPE_L 'L'

#define FORM_N 'N'
#define FORM_T 'T'
#define FORM_C 'C'

#define MODE_S 'S'
#define MODE_B 'B'
#define MODE_C 'C'

BOOL FAR PASCAL WS_AboutMsgProc(HWND, WORD, WORD, LONG);
BOOL FAR PASCAL WS_HostMsgProc(HWND, WORD, WORD, LONG);
BOOL FAR PASCAL WS_InputMsgProc(HWND, WORD, WORD, LONG);
BOOL FAR PASCAL WS_MainMsgProc(HWND, WORD, WORD, LONG);
BOOL FAR PASCAL WS_StatMsgProc(HWND, WORD, WORD, LONG);

int command(SOCKET socket, char *fmt,...);
int GetLocalInfo(VOID);
int DoCHMOD(SOCKET,LPSTR,LPSTR);
int DoCWD(SOCKET,LPSTR);
int DoDirList(SOCKET,LPSTR);
int DoMKD(SOCKET,LPSTR);
int DoPWD(SOCKET);
int DoQUOTE(SOCKET,LPSTR);
int DoRMD(SOCKET,LPSTR);
int DoSTAT(SOCKET);
int GetInputData(SOCKET sockfd,LPSTR buffer,int MaxRead);
int GetReply(SOCKET sockfd,LPSTR ptr);
int nCwRegisterClasses(void);
int ReadDisplayLine(SOCKET sockfd);
int ReadMass(SOCKET sockfd,LPSTR filename,BOOL binaryflag);
int readmsgin(SOCKET sockfd);
int RetrieveFile(SOCKET ctrl_socket,LPSTR szCMD,LPSTR localfile,char rtype);
int SendPacket(SOCKET sockfd,LPSTR ptr);
int SendFile(SOCKET ctrl_socket,LPSTR szCMD,LPSTR localfile,char stype);
int SendMass(SOCKET sockfd,LPSTR filename,BOOL binaryflag);
int sendstr(SOCKET sockfd,LPSTR ptr,int nbytes);

LONG FAR PASCAL WndProc(HWND, WORD, WORD, LONG);

LPSTR ReturnWSError(UINT Err,LPSTR szBuf);

SOCKET connectsock(char *host,char *service,char *protocol);
SOCKET connectTCP(char *host,char *service);
SOCKET connectUDP(char *host,char *service);
SOCKET DoClose(SOCKET sockfd);
SOCKET DoConnect(char *host);
SOCKET openFTPDataSocket(SOCKET sockfd, struct sockaddr_in *ctrladdr);

void cwCenter(HWND, int);
void CwUnRegisterClasses(void);
void DoAddLine(LPSTR);
void DoPaint(HWND);
void DoPrintf(char *fmt,...);
void ReleaseDisplayMem(VOID);
void ReportWSError(UINT Err);

#define DLG_STATUS                  2310
#define DLG_PROGRESS_BAR            104
#define BTN_LEDIT                   2115
#define BTN_LDISPLAY                2125
#define BTN_RDISPLAY                2225
